
# BARBARIAN KING
# Every 30s, summons a small army of barbarians
# Killing a nearby entity will enrage the king slightly
# Every 60s, King deals a massive amount of damage in front 
# This damage will leave the player (assuming they have 20 hearts)
# with half a heart of health left. 
# Abilities will be increased in potency for every 5 anger index.

execute as @e[tag=BossBarbarianKing] at @s if entity @a[distance=..25] run function clash:boss_effects/barbarian_king/_main

execute as @e[tag=BossBarbarianMob] at @s run function clash:boss_effects/barbarian_king/iron_fist_ability/spawned_entity_effects


# ARCHER QUEEN
# Every 30s, summons a small army of archers
# and becomes invisible, arrows shot deal 
# more damage queen fires more quickly
# Every minute it also becomes invisible and
# summons clones that have low health yet
# deal double the damage, they last for 10s
# as well as the invisibility effect

execute as @e[tag=BossArcherQueen] at @s if entity @a[distance=..25] run function clash:boss_effects/archer_queen/_main

execute as @e[tag=BossArcherMob] at @s run function clash:boss_effects/archer_queen/royal_cloak_ability/spawned_entity_effects

execute as @e[tag=Boss_ArcherQueenArrow_Proj] at @s run function clash:boss_effects/archer_queen/arrow_attack/proj/generic

execute as @e[tag=Boss_ArcherQueenClone] at @s run function clash:boss_effects/archer_queen/clone_ability/clone_effects

execute as @e[tag=Boss_ArcherQueen_Spread] at @s run function clash:boss_effects/archer_queen/clone_ability/spread


# GRAND WARDEN
# Becomes invincible every 30s.
# Standing near the boss causes the player to
# recieve mining fatigue.
# Every minute becomes a statue that fires rapidly, dealing too much damage
# near this boss will cause it to go into statue mode, while in this mode
# boss becomes very resistant to attacks.

execute as @e[tag=BossWarden] at @s if entity @a[distance=..25] run function clash:boss_effects/grand_warden/_main

execute as @e[tag=BossWarden_BeamAbility_Marker] at @s run function clash:boss_effects/grand_warden/beam/marker_effects

execute as @e[tag=BossWarden_StatueAbility_Marker] at @s run function clash:boss_effects/grand_warden/statue_ability/marker_effects

execute as @e[tag=BossWarden_BlockDisplay] at @s run function clash:boss_effects/grand_warden/statue_ability/display_effects

# ROYAL CHAMPION
# Every 30s, summons a shield that follows the player
# On contact, it will stun the player.
# If a player hasn't taken any damage for a number of secs.
# it will automatically execute this ability.
# Throws spears that deal damage according to the hit player's health.


execute as @e[tag=BossRoyalChampion] at @s if entity @a[distance=..25] run function clash:boss_effects/royal_champion/_main

execute as @e[tag=Boss_RoyalChampionSpear_Proj] at @s run function clash:boss_effects/royal_champion/spear_attack/proj/generic

execute as @e[tag=Boss_RoyalChampionShield_Proj] at @s run function clash:boss_effects/royal_champion/seeking_shield_ability/proj/generic

execute as @e[tag=Boss_RoyalChampion_PlayerStun] at @s run function clash:boss_effects/royal_champion/seeking_shield_ability/proj/stun_effects


# BATTLE MACHINE
# Every 30s, activates hammer ability which summons lightning bolts
# on activation, increased damage and speed of boss.
# Once the boss' health has reached 150hp, the rate of 
# abilities will be doubled along with an arrow-killing
# ability once the hammer ability is triggered
# Also, it will spawn lightning bolts on the player if the player
# deals too much damage. 

execute as @e[tag=BossBattleMachine] at @s if entity @a[distance=..25] run function clash:boss_effects/battle_machine/_main

execute as @e[tag=BossBattleMachine_LightningAbility_Marker] at @s run function clash:boss_effects/battle_machine/lightning_ability/marker_effects


# BATTLE COPTER
# Every 30s, activates special ability in which it hovers,
# then dashes towards the player while throwing a deadly bomb.
# Fires continouis attacks but with a slight pause
# in between rounds.
# Every 60s it will dash towards the player a total of 3 times
# while throwing bombs that will slow and weaken the player
# while also dealing damage

execute as @e[tag=BossBattleCopter] at @s if entity @a[distance=..25] run function clash:boss_effects/battle_copter/_main

execute as @e[tag=BossBattleCopter_BulletProj] at @s run function clash:boss_effects/battle_copter/attack/bullet_proj/generic

execute as @e[tag=BossBattleCopter_BombProj] at @s run function clash:boss_effects/battle_copter/dash/bomb_proj/generic

execute as @e[tag=BossBattleCopter_ThrownBombProj] at @s run function clash:boss_effects/battle_copter/bomb_throw/bomb_proj/generic





# M.O.M.M.A.

# Attacks cause players to explode, dealing the same damage
# as a giant bomb. Boss is also slow but has a huge amount 
# of hitpoints.

execute as @e[tag=MommaBoss] at @s run function clash:boss_effects/momma/_main


# Giant Dragon

# Fire breath attacks have a greater range than a regular dragon. 
# Whenever a player deals damage (and is close) it will start
# spamming a firebreath attack that can kill if not careful. 
# Boss also has a massive amount of hit points.

execute as @e[tag=GiantDragonBoss] at @s run function clash:boss_effects/giant_dragon/_main

# This is what replaces the regular blaze attack
execute as @e[tag=GiantDragon_Firebreath_Marker] at @s run function clash:boss_effects/giant_dragon/firebreath_main

# King

# This boss fight is heavily centered around fighting mobs.
# This boss will continously spawn troops.
# This boss will be invincible until the player has taken 
# out the princesses from both towers.
# The boss will spawn troops faster once they've gone down.
# Every so often, this boss will cast a spell on the player.

execute as @e[tag=KingBoss] at @s if entity @a[distance=..25] run function clash:boss_effects/king/_main

execute as @e[tag=King_Spell_To_Spawn_Marker] at @s run function clash:boss_effects/king/spawned_marker

execute as @e[tag=King_Enemy_To_Spawn_Marker] at @s run function clash:boss_effects/king/spawned_marker

execute as @e[tag=King_Spawned_Entity] at @s run function clash:boss_effects/king/spawned_entity_effects

execute as @e[tag=PrincessBoss] at @s run function clash:boss_effects/princess/_main


execute as @e[tag=Spell_Fireball] at @s run function clash:boss_effects/king/func_spells/fireball/_main

execute as @e[tag=Spell_Arrows] at @s run function clash:boss_effects/king/func_spells/arrows/_main
execute as @e[tag=Arrows_Spell_Arrow] at @s run function clash:boss_effects/king/func_spells/arrows/spawned_arrow_effects

execute as @e[tag=Spell_Goblin_Barrel] at @s run function clash:boss_effects/king/func_spells/goblin_barrel/_main

execute as @e[tag=Spell_Freeze] at @s run function clash:boss_effects/king/func_spells/freeze/_main
execute as @e[tag=Spell_Freeze_Marker] at @s run function clash:boss_effects/king/func_spells/freeze/marker_effects

execute as @e[tag=Spell_Rage] at @s run function clash:boss_effects/king/func_spells/rage/_main
execute as @e[tag=Spell_Rage_Marker] at @s run function clash:boss_effects/king/func_spells/rage/marker_effects
